#
# spec file for package rxvt-unicode (Version 8.3)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash binutils bzip2 coreutils cpio cpp cpp42 cracklib cvs diffutils file filesystem fillup findutils fontconfig fontconfig-devel freetype2 freetype2-devel gawk gcc gcc-c++ gcc42 gcc42-c++ gdbm gettext gettext-devel glibc glibc-devel glibc-locale grep groff gzip info insserv less libacl libattr libbz2-1 libbz2-devel libdb-4_5 libexpat-devel libexpat1 libgcc42 libgomp42 libltdl-3 libmudflap42 libreadline5 libstdc++42 libstdc++42-devel libtool libuuid1 libvolume_id libxcrypt libzio linux-kernel-headers m4 make man mktemp ncurses ncurses-devel net-tools netcfg pam pam-modules patch perl perl-base permissions pkg-config popt rpm sed sysvinit tar texinfo timezone util-linux xorg-x11-devel xorg-x11-fonts-devel xorg-x11-libICE xorg-x11-libICE-devel xorg-x11-libSM xorg-x11-libSM-devel xorg-x11-libX11 xorg-x11-libX11-devel xorg-x11-libXau xorg-x11-libXau-devel xorg-x11-libXdmcp xorg-x11-libXdmcp-devel xorg-x11-libXext xorg-x11-libXext-devel xorg-x11-libXfixes xorg-x11-libXfixes-devel xorg-x11-libXmu xorg-x11-libXmu-devel xorg-x11-libXp xorg-x11-libXp-devel xorg-x11-libXpm xorg-x11-libXpm-devel xorg-x11-libXprintUtil xorg-x11-libXprintUtil-devel xorg-x11-libXrender xorg-x11-libXrender-devel xorg-x11-libXt xorg-x11-libXt-devel xorg-x11-libXv xorg-x11-libXv-devel xorg-x11-libfontenc xorg-x11-libfontenc-devel xorg-x11-libs xorg-x11-libxcb xorg-x11-libxcb-devel xorg-x11-libxkbfile xorg-x11-libxkbfile-devel xorg-x11-proto-devel xorg-x11-util-devel xorg-x11-xtrans-devel zlib zlib-devel


Name:           rxvt-unicode
Version:        8.3
Release:        16.2
#
License:        LGPL v2.1 or later
Group:          System/X11/Terminals
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  freetype2-devel gcc-c++ pkgconfig xorg-x11-devel
# for tic
BuildRequires:  ncurses-devel
Provides:       locale(xorg-x11:ja;ko;zh)
#
%define with_terminfo_files 0
# FIXME: this should be < 1011 but the number isnt bumped yet
%if %{suse_version} <= 1010
%define with_terminfo_files 1
%define _terminfo      /usr/share/terminfo
%endif
#
Url:            http://software.schmorp.de/#rxvt-unicode
Source:         http://dist.schmorp.de/%{name}/%{name}-%{version}.tar.bz2
Source1:        rxvt-unicode-rpmlintrc
Source2:        rxvt-unicode.README.SuSE
Patch:          rxvt-unicode-7.7_missing_sentinel.patch
Patch1:         rxvt-unicode-8.3_transparent_terminal.patch
Patch2:         rxvt-unicode-8.3-CVE-2008-1142-DISPLAY.patch
#
Summary:        Rxvt X Terminal with Unicode Support

%description
rxvt-unicode is a clone of the well-known terminal emulator rxvt,
modified to store text in Unicode (either UCS-2 or UCS-4) and to use
locale-correct input and output. It also supports mixing multiple fonts
at the same time, includingXft fonts.



Authors:
--------
    Marc Lehmann <rxvt@schmorp.de>

%debug_package
%prep
%setup -q
%patch
%patch1
%patch2
find -type d -name CVS -print0 | xargs -r0 rm -r
%{__install} -m 0644 %{S:2} README.SuSE

%build
./autogen.sh
# cant use the configure macro here ... 
# the script handles prefix in a not so nice manner
%if %{suse_version} < 1011
%define _prefix %{_usr}/X11R6
%define _mandir %{_usr}/share/man/
%endif
#
export CFLAGS="%{optflags} -fno-strict-aliasing -Wno-unused -DXPM_INC_X11=1"
export CXXFLAGS="$CFLAGS"
%configure \
    --with-term="%{name}" \
    --enable-shared \
    --disable-strings \
    --enable-xft \
    --enable-font-styles \
    --enable-unicode3 \
    --enable-combining \
    --with-codesets=all \
    --enable-utmp \
    --enable-wtmp \
    --enable-lastlog \
    --enable-xpm-background \
    --enable-transparency \
    --enable-tinting \
    --enable-fading \
    --enable-menubar \
    --enable-next-scroll \
    --enable-rxvt-scroll \
    --enable-xterm-scroll \
    --enable-plain-scroll \
    --enable-half-shadow \
    --enable-perl \
    --enable-xgetdefault \
    --enable-xim \
    --enable-ttygid \
    --enable-fallback \
    --enable-linespace \
    --enable-24bit \
    --enable-keepscrolling \
    --enable-selectionscrolling \
    --enable-mousewheel \
    --enable-slipwheeling \
    --enable-smart-resize \
    --enable-iso14755 \
    --enable-cursor-blink \
    --enable-text-blink \
    --enable-pointer-blank \
    --enable-8bitctrls \
    --enable-frills \
%if %{?suse_version} >= 1010
    --with-xpm-includes=%{_prefix}/include \
    --with-xpm-library=%{_prefix}/%{_lib} \
%endif
    --with-xpm
%{__make}

%install
%if %with_terminfo_files
# no longer install the terminfo file as it is part of the terminfo package now
%{__install} -Dd -m 0755 "%{buildroot}%{_terminfo}/r"
TERMINFO="%{buildroot}%{_terminfo}" %makeinstall
%else
%makeinstall
%endif
#
%{__mkdir} examples/
%{__cp} -av doc/embed* doc/rxvt-tabbed doc/pty-fd examples/

%clean
%{__rm} -rf "%{buildroot}"

%files
%defattr(-,root,root)
%doc Changes README* doc/README* doc/changes.txt
%doc doc/etc doc/*.html
%doc examples/
%{_bindir}/urxvt*
%if %with_terminfo_files
%dir %{_terminfo}/r
%{_terminfo}/r/%{name}
%endif
%{_mandir}/man1/urxvt*
%{_mandir}/man3/urxvt*
%{_mandir}/man7/urxvt*
%dir %{_libdir}/urxvt/
%dir %{_libdir}/urxvt/perl
%{_libdir}/urxvt/urxvt.pm
%{_libdir}/urxvt/perl/digital-clock
%{_libdir}/urxvt/perl/example-refresh-hooks
%{_libdir}/urxvt/perl/selection
%{_libdir}/urxvt/perl/block-graphics-to-ascii
%{_libdir}/urxvt/perl/matcher
%{_libdir}/urxvt/perl/option-popup
%{_libdir}/urxvt/perl/searchable-scrollback
%{_libdir}/urxvt/perl/selection-autotransform
%{_libdir}/urxvt/perl/selection-popup
%{_libdir}/urxvt/perl/urxvt-popup
%{_libdir}/urxvt/perl/automove-background
%{_libdir}/urxvt/perl/selection-pastebin
%{_libdir}/urxvt/perl/readline
%{_libdir}/urxvt/perl/tabbed
%{_libdir}/urxvt/perl/remote-clipboard
%{_libdir}/urxvt/perl/xim-onthespot
%{_libdir}/urxvt/perl/kuake
%{_libdir}/urxvt/perl/macosx-clipboard

%changelog
* Mon Aug 11 2008 - mrueckert@suse.de
- added rxvt-unicode-8.3-CVE-2008-1142-DISPLAY.patch: (bnc#415661)
  do not fallback to :0 if $DISPLAY is not set (CVE-2008-1142)
* Tue Aug 28 2007 - mrueckert@suse.de
- added rxvt-unicode-8.3_transparent_terminal.patch: (#153423)
  fix disappearing window decorations with metacity
  (patch by Emanuele Giaquinta <exg@irssi.org>)
* Thu Aug 23 2007 - mrueckert@suse.de
- added a README.SuSE: (#231855)
  Explain how to enable colored bold/underline on urxvt.
* Sun Aug 05 2007 - mrueckert@suse.de
- fix rpmlint warnings:
  * package scripts from doc dir in examples/
  * add rpmlintrc for the scripts in %%{_libdir}/%%{name}
* Sat Aug 04 2007 - mrueckert@suse.de
- update to version 8.2:
  - new option: skipScroll/-ss, enabled by default.
  - go with the times and expect x11 library files in /usr/lib, not
  /usr/X11R6/lib.
  - initial transparency improvement/afterimage support patch by
  Sasha Vasko.
  - add urgentOnBell resource to set the urgency hint
  (patch by Philip Paeps).
  - do not process focus events caused by grabs (patch by Mikachu).
  - add iso14755_52 resource to disable iso14755 5.2 (exg).
  - add binding for backspace in iso14755 5.1 to remove the last
  digit (exg).
  - better option handling, support more than 30 options (exg).
  - nuke reconf script, serves no purpose anymore.
  - fixed and documented matcher/on_user_command processing in
  matcher extension (tpope).
  - compile out of the box on Solaris 10 (exg).
  - fix MappingNotify events (reported by Stephan Walter).
  - zero-initialise mwmhints, this seems to solve all sorts of
  minor problems.
- remove upstreamed patches:
  rxvt-unicode-8.2_missing_stdlib_h.patch
  rxvt-unicode-ptytty.patch
* Wed Apr 04 2007 - mrueckert@suse.de
- fixed order of changelog entries
* Fri Feb 23 2007 - mrueckert@suse.de
- modified fix-x-locale-detection-x11r7.patch to use the same fix
  as rxvt-unicode-ptytty.patch. new name is
  rxvt-unicode-8.2_missing_stdlib_h.patch
  This change obsoletes rxvt-unicode-7.7_utmp_including.patch.
- removed rxvt-unicode-7.7_gcc-warnings.patch
* Sun Feb 18 2007 - mrueckert@suse.de
- update to version 8.2:
  - fix make depend in src/, reported by exg.
  - fixed typo in urxvt::GET_CUSTOM, causing the result to be
  wrong. (patch by Sergey Vlasov).
  - unbundled iom perl interface somewhat.
  - scrollbar-xterm now uses the selected scrollColor instead of
  fg (found by Aiviru).
  - disabled linux kernel bug workaround again: disabling it
  gives a 50%% speed hit on affected machines, while enabling
  it gives a similar speed hit to screen, which is likely the
  more common case to work around for :/
  - urxvt::rend2mask perl function, and utilization of it by
  matcher (patch by Moshe Kamensky).
  - use perl:matcher on a keysym to open most recently displayed
  URL.
  - with matcher, when multiple patterns match, last wins, not
  first.
  - fix make and make install with srcdir != builddir.
  - updated bundled libptytty to fix a bug where the tty would be
  kept open (see the libptytty ChangeLog for details).
  - delay setting the IUTF8 flag to after the tty settings have
  been set so its value does not get lost (reported and analysed
  by Andrei Paskevich).
  - rip out support for obsolete sgtty.h interface.
  - rip out support for non-POSIX termios variants.
  - update libptytty.
  - update iom.C, make it call ptytty::sanitise_stdfd on init.
  - when !XFT, change rounding of colours to use a less correct
  formula to meet user expectancies (#aaa becomes #a000a000a000
  not #9f9f9f9f9f9f).
  - change the starting offset of the pixmap set with
  backgroundPixmap from (50,50) to (0,0).
  - fix a typo in button_release, now meta-button2 request the
  value of the Clipboard selection as it should (patch by Serge
  Koksharov).
  - fix a bug in drawing a cell with a nonspacing char when using
  an xft font with inheritPixmap and tintColor.
* Wed Jan 17 2007 - mrueckert@suse.de
- update to version 8.1:
  - fix the assumption that chars < 256 are single-width. Now only
  assume this for codepoints 32 to 126 (reported by Dai.H.).
  - $term->strwidth returned wide chars as width 1, because some
  jerk confused min and max. Fixing this also fixes xim-onthespot.
  Reported by Takano Akio.
  - secondaryScroll is now enabled by default (as per the manpage),
  reported by exg.
  - correct the description of [percent]color rgba format in the
  manpage.
  - incorporated macosx-clipboard extension by Samuel Ljungkvist.
  - ignore (some) useless focus events. (reported by mmc)
  - updated compose table to unicode 5.0.0.
* Fri Nov 03 2006 - mrueckert@suse.de
- uptdate to version 8.0:
  Combining characters will no longer erase the characters below
  them. Font bold/italic morphing will not be applied to
  manually-specified fonts. A crash when using non-UTF-8 locales
  (e.g. C) has been fixed. The powerful "matcher" extension now
  replaces mark-urls. The outline cursor color is now correct;
  starting urxvtc in an inaccessible directory no longer crashes
  urxvtd.
* Mon Aug 14 2006 - mfabian@suse.de
- fix configure.ac test for working Xlocale (makes XIM work again).
* Fri Aug 11 2006 - mfabian@suse.de
- move stuff from /usr/X11R6/ to /usr/ (because of X11R7).
* Tue Aug 08 2006 - mrueckert@suse.de
- Update to version 7.9:
  * fix the crashing bug people encountered with 7.8 + urxvtd +
  perl + transparency. Oight to fix debian bug #380348.
  * fix urxvtc.1.pod: it actually claimed -pty-fd would not work.
  But it does! :->
  * rxvt_fatal() in case the locale string is too long for our
  static buffer.
  * fixed many, many, typos in the manpages (patch supplied by ves)
* Mon Aug 07 2006 - mrueckert@suse.de
- added -DXPM_INC_X11=1 to the CFLAGS so we properly link with xpm
  on 10.2 and newer
- a little bit spec file cleanup
* Thu Jul 20 2006 - mrueckert@suse.de
- Update to version 7.8:
  This release primarily fixes a lot of bugs but also adds a few
  minor features: unlike Xt and previous versions, rxvt-unicode
  now always reads $HOME/.Xdefaults, a kuake-like extension has
  been added, Xft and X11 colours now agree (this fixes colour
  banding effects), hilightcolour-support has been re-enabled,
  the "depth" resource is now respected, several Debian patches
  have been integrated, and double-buffered Xft is now
  configurable via features.h. Many minor bugs have been fixed.
- WARNING this version seems to have a broken daemon mode (urxvtd)
* Thu Jul 20 2006 - schwab@suse.de
- Fix broken configure check.
* Mon Jul 17 2006 - mrueckert@suse.de
- added rxvt-unicode-7.7_utmp_including.patch:
  UTMP_FILE is defined in /usr/include/utmp.h
  if you want to check for it, you have to include it before
  checking for it.
* Tue May 23 2006 - mrueckert@suse.de
- No longer install the terminfo file. It is part of the terminfo
  package now.
* Tue May 16 2006 - mrueckert@suse.de
- Update to version 7.7
  o use double-buffered drawing (xft fonts only). On many
  driver/hardware combination this actually increases xft
  drawing speed, at the expense of more network bandwidth and
  slight nausea on the side of the author.
  o readline perl extension now requires shift-click instead of
  a normal click, and eats the click.
  o tabbed perl extension now supports -e.
  o disabled graphics-exposures on the main drawing GC, report
  any refresh bugs please.
  o improve property handling for -pe tabbed: avoid unnecessary
  property changes (for kde's benefit) at the expense of extra
  round-trips, improve size hint setting.
  o modified XIM according to a patch sent by Takano Akio that
  sets the preedit rectangle for OverTheSpot, which helps some
  input methods to correctly position their preedit window.
  o un-optimise the line clearing on newly scrolled-in lines a
  bit: the former reasoning was that any fg colour on default bg
  looks the same in empts spaces, but thats not true when
  reversing (e.g.  selection), so also check for matching fg
  colours. This fixes the problem where selecting newly
  scrolled-in lines would exhibit wrong colours.
  o fix a bug in the perl interface causing focus in events to
  generate focus out perl events, causing bad focus effects
  with -pe tabbed.
  o fix a race resulting in a crash on exiting.
  o fix a with --disable-xft that caused xfreecolors to be called
  on colors never allocated, resulting in aborts
  (reported by Paco-Paco).
  o resources on non-initial screens weren't refetched correctly
  (reported by Paco-Paco).
  o fix a bug in xcopyarea pass and _disable_ it, as it seems not
  to be working in either rxvt-unicode nor in the original rxvt.
  o removed undocumented -exec alias for the -e option.
- Additional changes from 7.6:
  o changed interpretation of [alpha] colour prefix.
  o +option now really sets the option to default, instead of
  using the resource value.
  o options that require an argument now really _require_ an
  argument.
  o the tabbed extension now forwards focus and keys events to
  th relevant tab window.
  o tab colours are now configurable and have sensible defaults
  (initial patch by hednod).
  o option menu is extendable, readline, selection and selection-
  autotransform can now be disabled/enabled at runtime.
  o forcing a configure event to tabbed subwindows with -pe
  tabbed, for the benefit of automove-background.
  o the automove-background extension added a wrong constant
  offset.
  o force refresh of XA_RESOURCE_STRING on virtual reconnect.
  o return exit status 2 in urxvtc when urxvtd couldn't be
  contacted.
  o the linux yield hack is back, now using usleep, and enabled
  only on __linux__.
  o further round trip eliminations in the !XFT case by
  remembering the colour components.
  o plain scrollbar works better with -sr.
  o fixed half-shadow scrollbar look.
  o more colour rtt optimisations.
  o properly(?) free colours on window close.
  o reorganised the FAQ into multiple sections.
  o add ISO646.1991-IRV to the list of supported codesets.
  o minor libptytty update.
* Wed Mar 01 2006 - mfabian@suse.de
- add "Provides: locale(xorg-x11:ja;ko;zh)".
* Wed Feb 01 2006 - mrueckert@suse.de
- Update to version 7.5
  o further improvements to the careful mode detection, and font width
  detection:
  o fully double-wide fonts will now be correctly treated,
  o overlap detection was improved.
  o detect totally broken fonts (usually synthesized by xft).
  o careful mode forced refresh sometimes clashed with blinking,
  causing unnecessary screen redraws.
  o better handling of XFT combining characters.
  o enable antialiasing for some replacement fonts, as they
  might get used for other encodings which really need it, later.
  o remove spacing=100 from all default fonts, as this creates totally
  weird spacing (5 times normal) with xft.
  o removed iso10646 fallback, as xorgs iso10646 encoded fonts are mostly
  broken.
  o removed gnu unifont fallback, all combining characters are broken.
  o replace named colours by xorg's rgb.txt equivalents, to
  reduce round trip time on startup, and short-cut allocation
  of rgb:rr/gg/bb for xft.
  o short-cut allocation of rgb values in the xlib case
  (patch by Paco-Paco).
  o overhauled color management: smaller codesize, alpha support.
  o support "rgba:rrrr/gggg/bbbb/aaaa" color specifications and
  an "[alpha]" prefix.
  o try to work around Xft and Xrender forcing everything to be 100%
  transparent. Long Live Xft!
  o do not include X11/Intrinsic.h anymore, directly use
  Xlib/Xutil/Xresource directly.
  o try to find a nearest matching color when color allocation fails
  on a pseudocolor screen.
  o SYNCCVS: compared to rxvt-cvs 2006-01-28, no relevant changes.
  o fix version report (DA) (which was unfortunately broken).
  o changed version number report again, now to emulate xterm closer.
  o added the OSC sequence 702 to detect the urxvt version number.
  o small configure updates.
  o further RTT optimisations.
- additional changes from 7.4
  o screen background wasn't always erased properly when scrolling,
  o re-enabled clearing optimisation disabled in 7.4pre.
  o small configure updates for libptytty.
  o fixed version options: line output.
  o removed stoopid debugging message left in the code.
* Fri Jan 27 2006 - mrueckert@suse.de
- update to 7.3
  o don't let iso14755 or mouse reporting get into the way of perl
  (could lead to global grabs never being cleared).
  o experimental OnTheSpot editing support (-pe xim-onthespot).
  o moved Shift-Button2 paste combination to Meta-Button2.
  o the cutchars resource will now be respected and used by the
  selection extension.
  o added the "remote-clipboard" extension which just runs
  external commands to fetch and store the selection data.
  o added -depth switch that tries to get a different visual depth
  than the default (replaces the old PREFER_24_BIT logic).
  o removed (unused) arabic presentation form composing sequences.
  o be more strict when deciding that a core font glyph is too
  wide and needs the careful rendering mode.
  o allow more leeway for italic fonts when deciding that a
  character is too wide and needs careful mode.
  o redraw even more characters around characters using careful
  mode.
  o made selection-pastebin fully asynchronous.
  o reduced number of server turnarounds at startup by allocating
  atoms only once per display.
  o renamed on_keyboard_command to on_user_command.
  o changed version sos (ESC [ > c) response to be more compatible
  with xterm.
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 23 2006 - mrueckert@suse.de
- update to version 7.2
* Fri Jan 20 2006 - mrueckert@suse.de
- update to version 7.1
- removed rxvt-unicode-5.6-configure.in.patch
- added rxvt-unicode-7.1_gcc-warnings.patch to fix at least the
  "is used uninitialized"
* Sat Jan 14 2006 - mrueckert@suse.de
- updated to 7.0
- removed rxvt-unicode-security.patch. we have seteuid/setegid
  so the path isnt even used.
- updated xpm patch for 7.0
* Tue Jan 10 2006 - lmichnovic@suse.cz
- added 3 patches
  rxvt-unicode-always_true_if.patch
  rxvt-unicode-xpm_buildhack.patch (reenabled --with-xpm flag)
  rxvt-unicode-security.patch (from package rxvt)
* Sun Jan 08 2006 - mrueckert@suse.de
- reenabled old meta key behavior.
- disabled xpm background until i fixed the build
- install into /usr/X11R6
* Thu Jan 05 2006 - mrueckert@suse.de
- Update to version 6.3
 - bugfixes
 - perl support
- added a small patch to fix a missing return statement
- added -fno-strict-aliasing
* Tue Jan 03 2006 - mrueckert@suse.de
- Update to 6.2
  - improved terminal handling with even fewer resource usage.
  - many small bug fixes.
* Sun Dec 18 2005 - mrueckert@suse.de
- Update to version 5.9
 - fixed signal handling in urxvtd
 - if fontconfig returns invalid fonts abort with error message
  instead of just crashing.
 - initialize menu properly
* Tue Dec 06 2005 - mrueckert@suse.de
- Applied small patch to fix a problem in current fontconfig.
  Instead of crashing it exists with a nice error message now. ;)
* Wed Oct 26 2005 - mrueckert@suse.de
- Update to version 5.8
* Wed Jul 13 2005 - mrueckert@suse.de
- Update to version 5.7
* Wed Jun 08 2005 - mrueckert@suse.de
- Started package with version 5.5.
